Re: [PATCH 2/2] perf test: Introduce script for java symbol testing

From: Arnaldo Carvalho de Melo
Date: Fri Aug 12 2022 - 15:47:52 EST


Em Sat, Aug 06, 2022 at 11:34:34AM +0800, Leo Yan escreveu:
> This commit introduces a script for testing java symbols.
>
> The test records for java program, inject samples with JIT samples, then
> check specific words "Interpreter" and "jdk.internal" in the report, the
> test will pass if these two symbols are detected.
>
> Signed-off-by: Leo Yan <leo.yan@xxxxxxxxxx>
> ---
> tools/perf/tests/shell/test_java_symbol.sh | 66 ++++++++++++++++++++++
> 1 file changed, 66 insertions(+)
> create mode 100755 tools/perf/tests/shell/test_java_symbol.sh
>
> diff --git a/tools/perf/tests/shell/test_java_symbol.sh b/tools/perf/tests/shell/test_java_symbol.sh
> new file mode 100755
> index 000000000000..45d42a9fdca5
> --- /dev/null
> +++ b/tools/perf/tests/shell/test_java_symbol.sh
> @@ -0,0 +1,66 @@
> +#!/bin/bash
> +# Test java symbol
> +
> +# SPDX-License-Identifier: GPL-2.0
> +# Leo Yan <leo.yan@xxxxxxxxxx>, 2022
> +
> +PERF_DATA=$(mktemp /tmp/__perf_test.perf.data.XXXXX)
> +PERF_INJ_DATA=$(mktemp /tmp/__perf_test.perf.data.inj.XXXXX)
> +
> +cleanup_files()
> +{
> + echo "Cleaning up files..."
> + rm -f ${PERF_DATA}
> + rm -f ${PERF_INJ_DATA}
> +}
> +
> +trap cleanup_files exit term int
> +
> +if [ -e "$PWD/tools/perf/libperf-jvmti.so" ]; then
> + LIBJVMTI=$PWD/tools/perf/libperf-jvmti.so


Will this only work if we do a:

make -C tools/perf

?

> +elif [ -e "$PWD/libperf-jvmti.so" ]; then
> + LIBJVMTI=$PWD/libperf-jvmti.so
> +elif [ -e "$PREFIX/lib64/libperf-jvmti.so" ]; then
> + LIBJVMTI=$PREFIX/lib64/libperf-jvmti.so
> +elif [ -e "$PREFIX/lib/libperf-jvmti.so" ]; then
> + LIBJVMTI=$PREFIX/lib/libperf-jvmti.so
> +else
> + echo "Fail to find libperf-jvmti.so"
> + exit 1
> +fi
> +
> +cat <<EOF | perf record -k 1 -o $PERF_DATA jshell -s -J-agentpath:$LIBJVMTI
> +int fib(int x) {
> + return x > 1 ? fib(x - 2) + fib(x - 1) : 1;
> +}
> +
> +int q = 0;
> +
> +for (int i = 0; i < 10; i++)
> + q += fib(i);
> +
> +System.out.println(q);
> +EOF
> +
> +if [ $? -ne 0 ]; then
> + echo "Fail to record for java program"
> + exit 1
> +fi
> +
> +if ! perf inject -i $PERF_DATA -o $PERF_INJ_DATA -j; then
> + echo "Fail to inject samples"
> + exit 1
> +fi
> +
> +# Below is an example of the instruction samples reporting:
> +# 8.18% jshell jitted-50116-29.so [.] Interpreter
> +# 0.75% Thread-1 jitted-83602-1670.so [.] jdk.internal.jimage.BasicImageReader.getString(int)
> +perf report --stdio -i ${PERF_INJ_DATA} 2>&1 | \
> + egrep " +[0-9]+\.[0-9]+% .* (Interpreter|jdk\.internal).*" > /dev/null 2>&1
> +
> +if [ $? -ne 0 ]; then
> + echo "Fail to find java symbols"
> + exit 1
> +fi
> +
> +exit 0
> --
> 2.25.1

--

- Arnaldo